  <script src="lib/LabelTypes.js"></script>
<script src="lib/Analysis.js"></script>
<script src="lib/Label.js"></script>

<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../iron-ajax/iron-ajax.html">

<dom-module id="dez-analysis">
  <template>

    <iron-ajax
        id="analysisFileRequest"
        url="{{dez}}"
        handle-as="json"
        debounce-duration="300"
        auto
        on-response="_analysisReady">
    </iron-ajax>

  </template>

  <script>
    /**
     * `dez-analysis`
     *
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class DezAnalysis extends Polymer.Element {

      static get is() { return 'dez-analysis'; }

      /**
      * Fired when analysis is erased.
      *
      * @event analysis-erased
      */

      /**
      * Fired when analysis is loaded from a json string.
      *
      * @event analysis-loaded
      */

      /**
      * When analysis is obtained by an Ajax request. This event is fired when
      * the response is received.
      *
      * @event analysis-ready
      */

      /**
      * Fired when a label has just been created.
      *
      * Data sent :
      * - label : label newly created
      * - operation : the create operation
      * - doneBy : initiator of the operation
      *
      * @event label-created
      */

      /**
      * Fired when a label has just been removed.
      *
      * Data sent :
      * - label : label id
      * - operation : the remove operation
      * - doneBy : initiator of the operation
      *
      * @event label-removed
      */

      /**
      * Fired when a label is selected.
      *
      * Data sent :
      * - label : selected label
      * - doneBy : initiator of the selection
      * @event label-selected
      */

      /**
      * Fired when a label has just been set.
      *
      * Data sent :
      * - label : updated label
      * - operation : the update operation
      * - doneBy : initiator of the operation
      *
      * @event label-set
      */

      static get properties() {
        return {
          /**
           * The dez file address
           *
           * @type {String}
           */
          dez: {
            type: String,
            observer: '_dezAttChanged'
          }
        };
      }

      /**
      * True if analysis changed since last cloud backup.
      *
      * @return {Boolean}
      */
      get backupNeeded () {
        return this._backupNeeded
      }

      set backupNeeded (value) {
        this._backupNeeded = value
      }

      /**
      * Object that manages label types and colors.
      *
      * @return {LabelTypes}
      */
      get labelTypes () {
        return this._labelTypes
      }

      /**
      * The currently selected label.
      *
      * @return {Label}
      */
      get selectedLabel () {
        if (this._selectedLabel == undefined) return undefined
        this._selectedLabel = this.getLabel(this._selectedLabel.id)
        return this._selectedLabel
      }

      get currentLabelModel () {
        if (this._selectionAfterModelChange && this.selectedLabel) {
          return {
            type : this.selectedLabel.type,
            tag : this.selectedLabel.tag
          }
        }
        return this._currentLabelModel
      }

      set currentLabelModel (labelModel) {
        this._selectionAfterModelChange = false
        this._currentLabelModel = {
          type : labelModel.type,
          tag : labelModel.tag
        }
        // is it the right place to execute these lines?
        // is color in the label model?
        this._labelTypes.setColorOfType(
          {type: labelModel.type, tag: labelModel.tag},
          labelModel.color
        )
        this.dispatchEvent(new CustomEvent('label-model-changed'))
      }

      /**
      * Labels in current analysis.
      *
      * @return {Array}
      */
      get labels () {
        return this._analysis.labels
      }

      /**
      * True if analysis is currently loading.
      *
      * @return {Boolean}
      */
      get loadingAnalysis () {
        return this._loadingAnalysis
      }

      /**
      * Tags used in the current analysis.
      *
      * @return {Array}
      */
      get usedTags () {
        return this._analysis.usedTags
      }

      constructor () {
        super();
        this._analysis = new Analysis()
        this._labelTypes = new LabelTypes();
        this._loadingAnalysis = false;
        this._backupNeeded = false;
        this._currentLabelModel = {
          type : "Pattern",
          tag : ""
        }
        this._musicIsPlaying = false
      }

      /**
      * Add a new label to the current analysis.
      * Fires the `label-created` event.
      *
      * @param {Object} label : object with data of the label
      * @param {String} doneBy : id of the client who wants to add the label
      */
      addLabel (label, doneBy) {
      	label=new Label(label)
        if(label.id == undefined){
          label.id = this._createRandomId()
        }
        this._analysis.addLabel(label)
        this._backupNeeded = true
        this.dispatchEvent(
          new CustomEvent(
            'label-created',
            {
              detail :  {
                label : this._analysis.getLabelById(label.id),
                operation : {
                  id : this._createRandomId(),
                  labelId : label.id,
                  action : "CREATE",
                  changes : label
                },
                doneBy : doneBy
              }
            }
          )
        )
        this._labelTypes.usedTags = this._analysis.usedTags.map(tag => tag.name )
        return label
      }

      /**
      * Update a label in the current analysis.
      * Fires the `label-set` event.
      *
      * @param {Object} label : label updated data
      * @param {id} doneBy : id of the client who wants to update the label
      */
      setLabel (label, doneBy) {
        let operation = this._toOperation(label, "UPDATE");
        this._analysis.updateLabel(new Label(label))
        this._labelTypes.usedTags = this._analysis.usedTags.map(tag => tag.name )
        this._backupNeeded = true
        this.dispatchEvent(
          new CustomEvent(
            'label-set',
            {
              detail :  {
                label : this._analysis.getLabelById(label.id),
                operation : operation,
                doneBy : doneBy
              }
            }
          )
        )
      }

      /**
      * Removes label with given id.
      * Fires the `label-removed` event.
      *
      * @param {String} id : given id
      * @param {String} doneBy : client who wants to remove the label
      */
      removeLabel (id, doneBy) {
        this._backupNeeded = true
        this.dispatchEvent(
          new CustomEvent(
            'label-removed',
            {
              detail : {
                labelId : id,
                operation: this._toOperation ({id : id}, "REMOVE"),
                doneBy: doneBy
              }
            }
          )
        )
        this._analysis.removeLabel(id)
        this._labelTypes.usedTags = this._analysis.usedTags.map(tag => tag.name )
      }

      /**
       * Load a new analysis from a location to make an Ajax request.
       * Asynchronous method.
       *
       * @param {String} location an url.
       * @return {Promise}
       */
      async loadAnalysisFrom (location) {
          this.dez = location
          return new Promise ((resolve) => {
            this.$.analysisFileRequest.addEventListener(
              "response",
              function handler() {
                // named function to be able to remove event listener
                resolve()
                this.$.analysisFileRequest.removeEventListener(
                  'response',
                  handler
                )
              }.bind(this)
            )
          })
      }

      /**
      * Load a new analysis from a json string.
      * Fires `analysis-loaded` event.
      *
      * @param {String} json
      */
      loadJson (json) {
        JSON.parse(json).labels.forEach(label => {
          label.line = this._lineOfLabel(label)
          this.addLabel(label)
        })
        this.dispatchEvent(new CustomEvent('analysis-loaded'))
      }

      loadCSV (csv) {
        let lines = csv.split('\n')
        let fields = lines[0].split(';')
        lines.slice(1).forEach(line => {
          let label = {}
          line.split(';').forEach((value, index) => {
            label[fields[index]] = value
          })
          label.line = this._lineOfLabel(label)
          label.start = parseFloat(label.start)
          if (label.duration) {
            label.duration = parseFloat(label.duration)
          } else {
            delete label.duration
          }
          this.addLabel(label)
        })
        this.dispatchEvent(new CustomEvent('analysis-loaded'))
      }

      /**
       * Erases the analysis and sends `analysis-erased` event.
       */
      erase () {
        this._analysis.erase()
        this.dispatchEvent(new CustomEvent('analysis-erased'))
      }

      /**
      * Update meta data of the current analysis.
      *
      * @param {Object} meta
      */
      updateMeta (meta) {
        this._analysis.updateMeta(meta)
      }

      /**
      * Get the label with the given id
      *
      * @param {String} id : given id
      * @return {Label} the label
      */
      getLabel(id) {
        return this._analysis.getLabelById(id)
      }

      /**
      * Add labels to the current analysis.
      * Fires `analysis-ready` and `analysis-loaded` events.
      *
      * @param {Array} labels
      */
      apply (labels) {
        this._analysis.erase()
        labels.forEach(label => {
          label.line = this._lineOfLabel(label)
          this.addLabel(label, "init")
        })
        this._loadingAnalysis = false;
        this.dispatchEvent(new CustomEvent('analysis-ready'))
        this.dispatchEvent(new CustomEvent('analysis-loaded'))
      }

      /**
      * Apply a label operation to the current analysis. An operation is
      * composed by:
      *
      * ```
      * {
      *   id : 'operationId',
      *   labelId : 'labelId',
      *   action : 'CREATE' | 'UPDATE' | 'REMOVE',
      *   changes : {
      *     property1: newValue1,
      *     ...
      *     propertyn: newValuen
      *   }
      * }
      * ```
      *
      * @param {Object} operation : data of the operation to apply
      */
      applyOperation(operation){
        if (operation.action == "CREATE") {
          let label = { id : operation.labelId }
          let changes = operation.changes
          Object.keys(changes).forEach (key => {
            if(key != "id" && changes[key] != undefined){
              label[key] = changes[key]
            }
          })
          this.addLabel(label, "collab");
        } else if (operation.action == "REMOVE") {
          this.removeLabel(operation.labelId,"collab")
        } else {
          let label = this._analysis.getLabelById(operation.labelId)
          let changes = operation.changes
          Object.keys(label).forEach(key=>{
            if(key != "id" && changes[key] != undefined){
              label[key] = changes[key]
            }
          })
          this.setLabel(label,"collab")
        }
      }

      /**
      * Notify that a label has been just selected.
      * Fires `label-selected` event.
      *
      * @param {String} id id of the selected label
      * @param {String} doneBy id of the client who has selected the label
      */
      selectLabel (id, doneBy) {
        this._selectedLabel = this.getLabel(id)
        this._selectionAfterModelChange = true
        this.dispatchEvent(
          new CustomEvent(
            'label-selected',
            {
              detail : {
                label: this._selectedLabel,
                doneBy : doneBy
              }
            }
          )
        )
      }

      /**
      * Get the current analysis as a json string.
      *
      * @return {String}
      */
      toJson () {
        return this._analysis.toJson()
      }

      /**
      * Get the current analysis as a CSV string.
      *
      * @return {String}
      */
      toCSV () {
        return this._analysis.toCSV()
      }

      /**
      * Get the current analysis as a string. Used for debug.
      * Groups and orders the stings by group of lines. For example:
      * - top
      * - staves
      * - bottom
      *
      * ```
      * sortedGroup = ["top", "staves", "bot"]
      * ```
      *
      * @param {Array} sortedGroups : ordered groups
      * @return {String}
      */
      toString (sortedGroups = []) {
        return this._analysis.toString(sortedGroups)
      }

      /**
      * Handler of dez property changes
      */
      _dezAttChanged () {
        this._backupNeeded = false
        this._loadingAnalysis = true
      }

      /**
      * Handler of the response of the Ajax request (uri = this.dez).
      *
      * @param {Event} event
      */
      _analysisReady(event) {
        this.apply(event.detail.response.labels)
      }

      /**
      * Get operation from the new value of an existing label. Get the
      * differences between the new and the old version of the label.
      *
      * @param {Object} label : object with data of the label
      * @param {String} action : the action key (CREATE | REMOVE | UPDATE)
      * @return {Object} the operation
      */
      _toOperation (label, action) {
        let ret = {
          id : this._createRandomId(),
          labelId : label.id,
          action : action,
          changes : {}
        }
        let orig = this._analysis.getLabelById(label.id)
        Object.keys(label).forEach(key => {
          if (label[key] != orig[key]) {
            ret.changes[key] = label[key]
          }
        })
        return ret
      }

      /**
      * Format the label line if it does not exist.
      *
      * @param {Object} label : label data
      * @return {String}
      */
      _lineOfLabel (label) {
        if (label.staff) return "staves." + label.staff
        if (label.line) return label.line;
        return this._labelTypes.defaultLineOf(label.type) || 'bot.3'
      }

      /**
      * Create a random id for new labels and new operations.
      *
      * @return {String} a random id
      */
      _createRandomId() {
            return (Math.random()*10000000).toString(16).substr(0,4)
            +'-'+(new Date()).getTime()
            +'-'+Math.random().toString().substr(2,5);
      }

    }

    window.customElements.define(DezAnalysis.is, DezAnalysis);
  </script>
</dom-module>
